//package dev.metin.OSC36;

import java.applet.Applet;
import java.awt.*;
import java.util.*;
import java.awt.Color;
//import EDU.syr.phy.mra.Style;
//import EDU.syr.phy.mra.HelpWindow;

// Everthing related to graphics is in this class.
class OscCanvas extends Canvas {
  Oscillator controller;
  Block m;		
  Dimension or1, or2;	// Oringins of force and energy graphs.
  Style S;
  public static final int AXS = 140;  // We need this for mode 1
  public static final int LVL = 250;  // Level at which block and spring is drawn.
  Tracer TF, TE; 		      // Tracers for force and energy graphs.
  int mode=1;			      // By default mode is 1.
  // Objects that we need for double buffering.
  Dimension offDimension;
  Image offImage;
  Graphics offGraphics;
  // Arrays to keep the values of force vs distance energy vs distance graphs. 
  int[] E = new int[500]; 
  int[] F = new int[500];
  // Some helpful booleans to keep track of what to do what not to do.
  boolean drag=false;		// Is Block draggable?
  boolean axis=true;		// Do we draw axis?
  boolean bg=true;		
  boolean spring=true;		// Do we draw the spring.
  boolean energy=true;		// Do we plot energy?
  boolean force=true;		// Do we plot force?

  double mass=1.0;	   
  double k=1.0;			// Spring constant.
  int x_offset=20;
  int y_offset=30;
  int min=55;
  int max=325;

  Base  b;

  public OscCanvas(Oscillator controller) {
     super();
     this.controller = controller;
     mode = controller.md;
     fill_up();
     if (mode==1) {
     m = new Block(min,LVL,50,50,0,0);
     or1=new Dimension(40,170);
     or2=new Dimension(220,170);      
     TF=new Tracer(or1.width,or1.height,or1.width,or1.width+AXS-2);
     TE=new Tracer(or2.width,or2.height,or2.width,or2.width+AXS-2);
     }
     if (mode==2) {
     m = new Block(190,LVL,50,50,70,70);
     or1=new Dimension(40+70,100);
     or2=new Dimension(220+70,100);      
     TF=new Tracer(or1.width,or1.height,or1.width-68,or1.width+68);
     TE=new Tracer(or2.width,or2.height,or2.width-68,or2.width+68);
     }	
     b = new Base(12,m.dim.height,x_offset-12,LVL-m.dim.height);
  }
  // Handle mouse down event by dragging the Block or Tracers when necessary.
  public boolean mouseDown(Event e, int x, int y) {
	if (!controller.Master) return true;
        return tango_mouseDown(e,x,y);
  }

  public boolean tango_mouseDown(Event e, int x, int y) {
    if (m.grab(x-x_offset,y)) drag=true; else drag=false;
    if (TF.grab(x,y)) TF.draggable=true; else TF.draggable=false;
    if (TE.grab(x,y)) TE.draggable=true; else TE.draggable=false;
	controller.cont.sendmsg("3"+x+","+y);
    return false;
  }

  public boolean mouseUp(Event e, int x, int y) {
	if (!controller.Master) return true;
        return tango_mouseUp();
  }

  public boolean tango_mouseUp() {
    	drag=false;
	controller.cont.sendmsg("4");
    return false;
  }

  public boolean mouseDrag(Event e, int x, int y) {
	if (!controller.Master) return true;
        return tango_mouseDrag(e,x,y);
  }

  public boolean tango_mouseDrag(Event e, int x, int y) {
    if((drag)&&(x<max)&&(x>min)){
      m.location.width=x;
      repaint();
    }
    else
    if((drag)&&(x<min)){
      m.location.width=min;
      repaint();
    }
    else
    if((drag)&&(x>max)){
      m.location.width=max;
      repaint();
    }
    else
    if((TF.draggable)&&(x<TF.x_max)&&(x>TF.x_min)){
      if (mode==1)
      m.location.width=min+2*(x-or1.width);
      if (mode==2)
      m.location.width=min+2*(x-or1.width+70);
      repaint();
    }
    else
    if((TF.draggable)&&(x<TF.x_min)){
      m.location.width=min;
      repaint();
    }
    else
    if((TF.draggable)&&(x>TF.x_max)){
      m.location.width=max;
      repaint();
    }
    else
    if((TE.draggable)&&(x<TE.x_max)&&(x>TE.x_min)){
      if (mode==1)
      m.location.width=min+2*(x-or2.width);
      if (mode==2)
      m.location.width=min+2*(x-or2.width+70);
      repaint();
    }
    else
    if((TE.draggable)&&(x<TE.x_min)){
      m.location.width=min;
      repaint();
    }
    else
    if((TE.draggable)&&(x>TE.x_max)){
      m.location.width=max;
      repaint();
    }
   
    //For tracking the upper and the lower bounds of motion.   
    
    int i=0;
    i=(m.location.width-min+5)/2;
    if (i<m.l_bound) m.l_bound=i;
    if (i>m.u_bound) m.u_bound=i;
	controller.cont.sendmsg("5"+x+","+y);    
    return false;
  }
  // Fill up the energy and force arrays.
  public void fill_up() {
  int i;
  if (mode==1) {
  for(i=0;i<140;++i)
    { 
      F[i]=(int) ((( (double)(force (i) )) /((double)(force (140)))*140.0));
      E[i]=(int) ((( (double)(energy(i) )) /((double)(energy(140)))*140.0));
    }
   }
  if (mode==2) {
  for(i=0;i<140;++i)
    { 
      F[i]=(int) ((( (double)(force (i-70) )) /((double)(force (70)))*70.0));
      E[i]=(int) ((( (double)(energy(i-70) )) /((double)(energy(70)))*70.0));
    }
   }
  }
  // Returns the force applied by the user at distance x from initial position.
  public int force(int x) {
  int r=0;
  r=(int)(k*(double)(x));
  return r;
  }  

  // Returns the potential energy of the spring at distance x from initial position.
  public int energy(int x) {
  int r=0;
  r=(int)(k*(double)(x*x)*.5);
  return r;
  }  

  // Draws the energy axes according to the current mode.
  public void E_axis(Graphics g) {
  g.setColor(S.axesColor);
  if (mode==1) {
  g.drawLine(or2.width,or2.height,or2.width+AXS,or2.height);
  g.drawLine(or2.width+AXS-6,or2.height-3,or2.width+AXS,or2.height);
  g.drawLine(or2.width+AXS-6,or2.height+3,or2.width+AXS,or2.height);

  g.drawLine(or2.width,or2.height,or2.width,or2.height-AXS);
  g.drawLine(or2.width,or2.height-AXS,or2.width+3,or2.height-AXS+6);
  g.drawLine(or2.width,or2.height-AXS,or2.width-3,or2.height-AXS+6);
   }
  if (mode==2) {
  g.drawLine(or2.width-70,or2.height,or2.width+70,or2.height);
  g.drawLine(or2.width-6+70,or2.height-3,or2.width+70,or2.height);
  g.drawLine(or2.width-6+70,or2.height+3,or2.width+70,or2.height);
  g.drawLine(or2.width-70+6,or2.height-3,or2.width-70,or2.height);
  g.drawLine(or2.width-70+6,or2.height+3,or2.width-70,or2.height);

  g.drawLine(or2.width,or2.height+70,or2.width,or2.height-70);
  g.drawLine(or2.width,or2.height+70,or2.width+3,or2.height+70-6);
  g.drawLine(or2.width,or2.height+70,or2.width-3,or2.height+70-6);
  g.drawLine(or2.width,or2.height-70,or2.width+3,or2.height-70+6);
  g.drawLine(or2.width,or2.height-70,or2.width-3,or2.height-70+6);
  }
  }

  // Draws the force axes according to the current mode.
  public void F_axis(Graphics g) {
  g.setColor(S.axesColor);
  if (mode==1) {
  g.drawLine(or1.width,or1.height,or1.width+AXS,or1.height);
  g.drawLine(or1.width+AXS-6,or1.height-3,or1.width+AXS,or1.height);
  g.drawLine(or1.width+AXS-6,or1.height+3,or1.width+AXS,or1.height);

  g.drawLine(or1.width,or1.height,or1.width,or1.height-AXS);
  g.drawLine(or1.width,or1.height-AXS,or1.width+3,or1.height-AXS+6);
  g.drawLine(or1.width,or1.height-AXS,or1.width-3,or1.height-AXS+6);
   }
  if (mode==2) {
  g.drawLine(or1.width-70,or1.height,or1.width+70,or1.height);
  g.drawLine(or1.width+70-6,or1.height-3,or1.width+70,or1.height);
  g.drawLine(or1.width+70-6,or1.height+3,or1.width+70,or1.height);
  g.drawLine(or1.width-70+6,or1.height-3,or1.width-70,or1.height);
  g.drawLine(or1.width-70+6,or1.height+3,or1.width-70,or1.height);

  g.drawLine(or1.width,or1.height+70,or1.width,or1.height-70);
  g.drawLine(or1.width,or1.height+70,or1.width+3,or1.height+70-6);
  g.drawLine(or1.width,or1.height+70,or1.width-3,or1.height+70-6);
  g.drawLine(or1.width,or1.height-70,or1.width+3,or1.height-70+6);
  g.drawLine(or1.width,or1.height-70,or1.width-3,or1.height-70+6);
   }
  }

  // Draws the line below the Block, and Base according to the current mode.
  public void path(Graphics g) {
  g.setColor(new Color(255,150,150));
  if (mode==1) {
  g.drawLine(x_offset+min-m.dim.width,m.location.height,x_offset+max,m.location.height);
  g.setColor(new Color(255,0,100));
  int fSize = 11;
  g.setFont(S.labels2Font);
  g.drawString("X_MIN",x_offset+min-m.dim.width,m.location.height+12);
  g.drawString("X_MAX",x_offset+max-(fSize*5)/2-2,m.location.height+12);
   }
   if (mode==2) {
  g.drawLine(x_offset+min-m.dim.width,m.location.height,x_offset+max,m.location.height);
  g.setColor(new Color(0,255,255));
  g.drawLine(x_offset+190,m.location.height,x_offset+190-m.dim.width,m.location.height);
  g.setColor(new Color(255,0,100));
  int fSize = 11;
  g.setFont(S.labels2Font);
  g.drawString("X_MIN",x_offset+min-m.dim.width,m.location.height+12);
  g.drawString("X_MAX",x_offset+max-(fSize*5)/2-2,m.location.height+12);
  g.drawString("Equilibrium",x_offset+190-(m.dim.width)/2-(fSize*12)/4,m.location.height+12);
   }
  }

  // Draws the spring according to the current mode.
  public void spring(Graphics g) {
  double arg=0.0;
  double phi=190.0/(m.location.width-m.dim.width);
  double dx=1.0/phi;
  for(arg=0.0; arg<m.location.width-m.dim.width; arg+=dx)
   {
     g.setColor((new Color(5,4,50)).darker());
     g.drawLine(
	(int)arg+x_offset,
	m.location.height-m.dim.height/2+(int)(Math.sin(arg/5*phi)*m.dim.height/3),
	(int)(arg+dx)+x_offset,
	(int)(Math.sin((arg+dx)/5*phi)*m.dim.height/3+m.location.height-m.dim.height/2)
        );
   }
  }
  
  // Plots the force according to the current mode.
  public void force(Graphics g) {
  g.setColor(S.labelsColor);
  if (mode==1) {
  g.drawString("F",or1.width, or1.height-AXS-10);
  g.drawString("X",or1.width+AXS+10, or1.height); 
  g.setColor(S.fg2DiagramColor);
  int i=0;
  for(i=m.l_bound;i<m.u_bound;++i){
  g.drawLine(i+or1.width,or1.height-F[i],i+1+or1.width,or1.height-F[i+1]);
    }
   }
  if (mode==2) {
  g.drawString("F",or1.width, or1.height-80);
  g.drawString("X",or1.width+80, or1.height); 
  g.setColor(S.fg2DiagramColor);
  int i=0;
  for(i=m.l_bound;i<m.u_bound;++i){
  g.drawLine(i+or1.width-70,or1.height-F[i],i+1+or1.width-70,or1.height-F[i+1]);
    }   
   }
  }

  // Plots the energy according to the current mode.
  public void energy(Graphics g) {
  if (mode==1) {
  g.setColor(S.labelsColor);
  g.drawString("E",or2.width, or2.height-AXS-10);
  g.drawString("X",or2.width+AXS+10, or2.height); 
  g.setColor(S.fg2DiagramColor);
  int i=0;
  for(i=m.l_bound;i<m.u_bound;++i){
  g.drawLine(i+or2.width,or2.height-E[i],i+1+or2.width,or2.height-E[i+1]);
    }
   }
  if (mode==2) {
  g.setColor(S.labelsColor);
  g.drawString("E",or2.width, or2.height-80);
  g.drawString("X",or2.width+80, or2.height); 
  g.setColor(S.fg2DiagramColor);
  int i=0;
  for(i=m.l_bound;i<m.u_bound;++i){
  g.drawLine(i+or2.width-70,or2.height-E[i],i+1+or2.width-70,or2.height-E[i+1]);
    }
   }
  }

  // Draws the force tracer according to the current mode.
  public void F_trace(Graphics g) {
  int i=0,tmp=0;
  if (mode==1) tmp=0; else tmp=70;
  i=(m.location.width-50)/2;
  g.setColor(new Color(255,105,105));
  g.drawOval(i+or1.width-tmp-1,or1.height-F[i]-2,2,2);
  g.drawOval(i+or1.width-tmp-2,or1.height-F[i]-2,4,4);
  g.drawOval(i+or1.width-tmp-3,or1.height-F[i]-3,6,6);
  TF.location = new Dimension(i+or1.width-tmp-1,or1.height-F[i]);
  }

  // Draws the energy tracer according to the current mode.
  public void E_trace(Graphics g) {
  int i=0,tmp;
  if (mode==1) tmp=0; else tmp=70;
  i=(m.location.width-50)/2;
  g.setColor(new Color(255,105,105));
  g.drawOval(i+or2.width-tmp-1,or2.height-E[i]-1,2,2);
  g.drawOval(i+or2.width-tmp-2,or2.height-E[i]-2,4,4);
  g.drawOval(i+or2.width-tmp-3,or2.height-E[i]-3,6,6);
  TE.location = new Dimension(i+or2.width-tmp-1,or2.height-E[i]);
  }

  // Double buffering.
  public void paint(Graphics g) {
  update(g);
  }
  
  // Graphics related code.
  public void update(Graphics g) {
  Dimension d= new Dimension(400,400);

  if ( (offGraphics == null)
          || (d.width != offDimension.width)
          || (d.height != offDimension.height) ) {
            offDimension = d;
            offImage = createImage(d.width, d.height);
            offGraphics = offImage.getGraphics();
        }

        offGraphics.setColor(S.bgDiagramColor);
        offGraphics.fillRect(0, 0,500,500);

  if (axis) path(offGraphics);
  if (spring) spring(offGraphics);

  if (force)  { F_axis(offGraphics); force(offGraphics);  F_trace(offGraphics); }
  if (energy) { E_axis(offGraphics); energy(offGraphics); E_trace(offGraphics); }

  offGraphics.setColor(S.fgDiagramColor);
  offGraphics.fillRect(x_offset+m.location.width-m.dim.width, m.location.height-m.dim.height,m.dim.width,m.dim.height);
  b.draw(offGraphics,1.0);
  g.drawImage(offImage, 0, 0, this);

  }
}
